#include <windows.h>
#include "StubPreamble.h"
#include "NativeSerialPort.h"

static HANDLE commHandles[5];
//static HANDLE staticIdComDev;
static HANDLE idComDev;  // test only
__declspec(dllexport) /*boolean*/ long NativeSerialPort_setup( 
	struct HNativeSerialPort* thePort, 
	long port, long baud, long parity, long bits, long stopBits ) {

	char cbuf[10];
	COMMTIMEOUTS CommTimeOuts;
//	HANDLE idComDev;
	DCB dcb;
	char commStr[50];
	DWORD nWritten;

	sprintf( cbuf, "COM%d:", port );
	printf( "cbuf: '%s', port %d, baud %d, parity %d, bits %d, stopBits %d\n", cbuf,
		port, baud, parity, bits, stopBits );
	// create the comm file
	idComDev = CreateFile( cbuf, GENERIC_READ | GENERIC_WRITE, 
		0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if ( idComDev == NULL ) {
		printf( "CreateFile failed\n" );
		return( 0 );
	} else {
		printf( "CreateFile succeeded\n" );
	}

	// set up buffers
	if ( !SetupComm( idComDev, 4096, 1024 )) {
		printf( "SetupComm failed, error %ld\n", GetLastError() );
		return( 0 );
	} else {
		CommTimeOuts.ReadIntervalTimeout = MAXDWORD;
		CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
		CommTimeOuts.ReadTotalTimeoutConstant = 0;
		CommTimeOuts.WriteTotalTimeoutMultiplier = 2;
		CommTimeOuts.WriteTotalTimeoutConstant = 2000;
		if ( !SetCommTimeouts( idComDev, &CommTimeOuts )) {
			printf( "SetCommTimeouts failed.\n" );
			return( 0 );
		} else {
			printf( "SetCommTimeouts succeeded.\n" );
		}
	}

	if ( GetCommState( idComDev, &dcb )) {
		printf( "GetCommState succeeded\n" );
	} else {
		printf( "GetCommState failed\n" );
		return( 0 );
	}

	sprintf( commStr, "COM%d: baud=%d parity=%c data=%d stop=%d", port, baud, parity, bits, stopBits );
	printf( "commStr is: '%s'\n", commStr );
	if ( BuildCommDCB( commStr, &dcb )) {
		printf( "BuildCommDCB succeeded\n" );
	} else {
		printf( "BuildCommDCB failed\n" );
		return( 0 );
	}

	if ( SetCommState( idComDev, &dcb )) {
		printf( "SetCommState succeeded\n" );
	} else {
		printf( "SetCommState failed\n" );
		return( 0 );
	}
	commHandles[ port ] = idComDev;

	return( 1 );
}

__declspec(dllexport) /*boolean*/ long NativeSerialPort_open( struct HNativeSerialPort* thePort ) {
}

__declspec(dllexport) void NativeSerialPort_close( struct HNativeSerialPort* thePort ) {
	CloseHandle( idComDev );
}

__declspec(dllexport) long NativeSerialPort_read( struct HNativeSerialPort* thePort,
	HArrayOfByte* bytes, long numberBytes ) {
	char* scan;
	DWORD iBytesRead;
	BOOL bStat;
	scan = unhand( bytes );
	bStat = ReadFile( idComDev, scan, numberBytes, &iBytesRead, NULL );
	if ( iBytesRead == 0 ) {
		return( -1 );
	}
	return( iBytesRead );
}

__declspec(dllexport) long NativeSerialPort_readByte( struct HNativeSerialPort* thePort ) {
}

__declspec(dllexport) long NativeSerialPort_write( struct HNativeSerialPort* thePort,
	HArrayOfByte* bytes, long numberBytes ) {
	char* scan;
	DWORD nWritten;
	BOOL bStat;
	char buf[50];
	scan = unhand( bytes );
	nWritten = 0;
	strncpy( &buf[0], scan, numberBytes );
	buf[ numberBytes ] = 0;
	printf( "Writing this: '%s', %d bytes\n", &buf[0], numberBytes );
	if ( WriteFile( idComDev, scan, numberBytes, &nWritten, NULL )) {
		printf( "WriteFile succeeded, wrote %d bytes\n", nWritten );
	} else {
		printf( "WriteFile failed, error %d\n", GetLastError() );
	}
	return( nWritten );
}
